View Issue Details

IDProjectCategoryView StatusLast Update
0003481Far ManagerHelp/Languagepublic2017-10-07 17:55
ReporterJohnDoeAssigned ToDrKnS 
PrioritynormalSeverityminorReproducibilityalways
Status assignedResolutionreopened 
Platformx86OSWindowsOS VersionXP SP3
Product Version3.0 
Target VersionFixed in Version3.0 
Summary0003481: hlf: Текст может выравниваться не смотря на отсутствие <CtrlStartPosChar>
DescriptionЕсли в топике не задана непрокручиваемая область, то не смотря на отсутствие в первой строке <CtrlStartPosChar>, со второй строки текст может ошибочно начать выравниваться.
Позиция выравнивания соответствует той, в которой символ задан в опциях.

Если символ в опциях не назначен, то проблемы нет.
Steps To Reproduce
Для воспроизведения достаточно:
1. CtrlStartPosChar должен быть задан
2. Непрокручиваемая опция должна отсутствовать
3. Текст должен быть достаточно длинным, чтобы не уместиться в одну строку

Пример:
.Language=Russian,Russian (Русский)
.Options CtrlColorChar=\
.Options CtrlStartPosChar=^<wrap>

@Contents=Help
@Help
    В оглавлении справочной системы имеются ссылки (они функционируют 
примерно
так же, как и гиперссылки, знакомые каждому пользователю 
Интернет), которые
указывают на разделы с более подробной информацией. Дополнительно 
на главной
странице находится "~Индекс файла помощи~@Index@", он показывает 
оглавления
всех страничек (топиков) имеющихся в файле помощи и, в ряде 
случаев, позволяет
быстрее найти необходимую информацию.


Отображается как:
╔══════════════════════ Help - FAR ══════════════════════╗

║    В оглавлении справочной системы имеются ссылки (они 
▲
║                          функционируют примерно так    ▓
║                          же, как и гиперссылки,        ▓
║                          знакомые каждому              ▓
║                          пользователю Интернет),       ▓
║                          которые указывают на разделы  ▓
║                          с более подробной             ▓
║                          информацией. Дополнительно    ▓
║                          на главной странице           ▓
║                          находится                     ▓
║                          "Индекс файла помощи", он     ▓
║                          показывает оглавления всех    ▓
║                          страничек (топиков)           ▓
║                          имеющихся в файле помощи и,   ▓
║                          в ряде случаев, позволяет     ▓
║                          быстрее найти необходимую     ░
║                          информацию.                   ░
Additional Informationhttp://forum.farmanager.com/viewtopic.php?f=9&t=10896
TagsNo tags attached.
Build5029

Activities

JohnDoe

2017-09-05 11:44

updater  

wrap_bug.hlf (1,297 bytes)

DrKnS

2017-09-11 22:51

administrator   bugnote:0015577

5027

JohnDoe

2017-09-12 11:24

updater   bugnote:0015579

Баг исправлен, но внесены новые.
Например, добавим CtrlStartPosChar в приложенном файле так:

...
@Contents=Help
@Help

    ^<wrap>В оглавлении справочной системы имеются ссылки 
(они функционируют примерно
...


Должно получиться так:

╔════════════════ Help - FAR ═════════════════╗

║                                             ▲
║    В оглавлении справочной системы имеются  ▓
║    ссылки (они функционируют примерно так   ▓
║    же, как и гиперссылки, знакомые каждому  ▓
<.............................................>
║                                             ░
║    Для перемещения между ссылками вы можете ░
║ использовать Tab и Shift-Tab. Нажатие Enter ░
║ вызовет страницу, соответствующую выбранной ▼

Вместо этого вижу

╔═════════════════ Help - FAR ═════════════════╗

║                                              ▲
║       В оглавлении справочной системы        ▓
║    имеются ссылки (они функционируют         ▓
║    примерно так же, как и гиперссылки,       ▓
<.............................................>
║                                              ▓
║       Для перемещения между ссылками вы      ░
║    можете использовать Tab и Shift-Tab.      ░
║    Нажатие Enter вызовет страницу,           ░

Т.е. тут 2 проблемы
1) Первый абзац должен быть в один уровень, без красной строки
2) Второй абзац должен быть на прежнем уровне, т.к. CtrlStartPosChar по идее действует до первой пустой строки (этого вроде нет в доке, но на практике так)

DrKnS

2017-09-12 23:05

administrator   bugnote:0015580

5028

JohnDoe

2017-09-13 10:42

updater   bugnote:0015583

Прошлые проблемы ушли, но есть новая.
.Language=Russian,Russian (Русский)
.Options CtrlStartPosChar=^<wrap>

@Contents

 Основные действия:
  #Enter#            ^<wrap>перейти к позиции предупреждения
  #Esc#              закрыть список и восстановить исходную позицию



Если ширины экрана хватает, чтобы отобразить строки не сворачивая, то в них появляется отступ.
╔═══════════════════════════════════════════════ 
Help - FAR ════════════════════════
║
║ Основные действия:
║                    Enter            перейти к позиции предупреждения

║                    Esc              закрыть список и восстановить исходную 
позицию


Если те же строки сворачиваются (при узком экране), то проблемы нет
╔═══════════════════════════ Help - FAR 
═════════
║
║ Основные действия:
║  Enter            перейти к позиции
║                   предупреждения
║  Esc              закрыть список и
║                   восстановить исходную позицию

JohnDoe

2017-09-13 10:58

updater   bugnote:0015584

И ещё.
.Language=Russian,Russian (Русский)
.Options CtrlStartPosChar=^<wrap>
@Contents
 ~Topic1~@Topic1@
 ~Topic2~@Topic2@

@Topic1

 Основные действия:
  #Enter#            ^<wrap>перейти к позиции предупреждения

  #Esc#              закрыть список и восстановить исходную позицию


@Topic2
 Plain text


Здесь в первом топике в строке Enter видим описанный выше баг.
Но в строке Esc всё нормально, потому что перед ней пустая строка, а значит предыдущий CtrlStartPosChar уже не действует.

Но открываем второй топик, и снова видим отступ: CtrlStartPosChar из прошлого топика почему-то снова в силе (не говоря уже о том, что он должен действовать только на хвосты строк)

DrKnS

2017-09-13 22:28

administrator   bugnote:0015587

Частично откатил последние изменения.

TrueColor остался, Fix #3485 остался, fix для _изначальной_ пробемы, опсисанной в этом тикете - остался, остальное, описанное в каментах тут и там - заводите отдельные баги, если ещё актуально.

JohnDoe

2017-09-14 09:04

updater   bugnote:0015588

Last edited: 2017-09-14 09:30

View 2 revisions

Ни один из описанных в обсуждении данного тикета багов больше не повторяется, спасибо.

Откат изменений привёл к тому, что вернулся баг, исправленный в другом тикете.
Зарепортил снова: 0003489

JohnDoe

2017-10-07 17:55

updater   bugnote:0015638

Переоткрыл.

.Language=Russian,Russian (Русский)
.Options CtrlColorChar=\
.Options CtrlStartPosChar=^<wrap>

@Contents=Help

                     ^<wrap>

@Help
    В оглавлении справочной системы имеются ссылки (они функционируют 

примерно
так же, как и гиперссылки, знакомые каждому пользователю 

Интернет), которые
указывают на разделы с более подробной информацией. Дополнительно 

на главной
странице находится "~Индекс файла помощи~@Index@", он показывает 

оглавления
всех страничек (топиков) имеющихся в файле помощи и, в ряде 

случаев, позволяет
быстрее найти необходимую информацию.


Позиция заданная за пределами топика не должна влиять, но влияет..

Issue History

Date Modified Username Field Change
2017-09-05 11:44 JohnDoe New Issue
2017-09-05 11:44 JohnDoe File Added: wrap_bug.hlf
2017-09-11 22:32 DrKnS Assigned To => DrKnS
2017-09-11 22:32 DrKnS Status new => assigned
2017-09-11 22:51 DrKnS Note Added: 0015577
2017-09-11 22:51 DrKnS Status assigned => feedback
2017-09-12 11:24 JohnDoe Note Added: 0015579
2017-09-12 11:24 JohnDoe Status feedback => assigned
2017-09-12 23:05 DrKnS Note Added: 0015580
2017-09-12 23:05 DrKnS Status assigned => feedback
2017-09-13 10:42 JohnDoe Note Added: 0015583
2017-09-13 10:42 JohnDoe Status feedback => assigned
2017-09-13 10:58 JohnDoe Note Added: 0015584
2017-09-13 22:28 DrKnS Note Added: 0015587
2017-09-13 22:28 DrKnS Status assigned => feedback
2017-09-14 09:04 JohnDoe Note Added: 0015588
2017-09-14 09:04 JohnDoe Status feedback => assigned
2017-09-14 09:30 JohnDoe Note Edited: 0015588 View Revisions
2017-09-14 10:05 DrKnS Build => 5029
2017-09-14 10:05 DrKnS Status assigned => closed
2017-09-14 10:05 DrKnS Resolution open => fixed
2017-09-14 10:05 DrKnS Fixed in Version => 3.0
2017-10-07 17:53 JohnDoe Status closed => feedback
2017-10-07 17:53 JohnDoe Resolution fixed => reopened
2017-10-07 17:55 JohnDoe Note Added: 0015638
2017-10-07 17:55 JohnDoe Status feedback => assigned